#include "vieter_tree.h"
#include "vieter_tree_node.h"

#include <stdbool.h>

struct vieter_tree {
  uint64_t size;
  vieter_tree_node *root;
};

/*
 * Inspect whether the tree is still a valid red-black-tree.
 *
 * @return true if valid, false otherwise.
 */
bool vieter_tree_validate(vieter_tree *tree);

struct vieter_tree_iterator {
    vieter_tree_node *current_node;
    bool started;
    bool done;
};
